=== unittests/Format/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Support
  )

add_clang_unittest(FormatTests
  BracesInserterTest.cpp
  BracesRemoverTest.cpp
  CleanupTest.cpp
  ConfigParseTest.cpp
  DefinitionBlockSeparatorTest.cpp
  FormatTest.cpp
  FormatTestComments.cpp
  FormatTestCSharp.cpp
  FormatTestJS.cpp
  FormatTestJava.cpp
  FormatTestJson.cpp
  FormatTestMacroExpansion.cpp
  FormatTestObjC.cpp
  FormatTestProto.cpp
  FormatTestRawStrings.cpp
  FormatTestSelective.cpp
  FormatTestTableGen.cpp
  FormatTestTextProto.cpp
  FormatTestVerilog.cpp
  FormatTokenSourceTest.cpp
  FormatReplacementTest.cpp
  IntegerLiteralSeparatorTest.cpp
  MacroCallReconstructorTest.cpp
  MacroExpanderTest.cpp
  MatchFilePathTest.cpp
  NamespaceEndCommentsFixerTest.cpp
  ObjCPropertyAttributeOrderFixerTest.cpp
  QualifierFixerTest.cpp
  SortImportsTestJS.cpp
  SortImportsTestJava.cpp
  SortIncludesTest.cpp
  UsingDeclarationsSorterTest.cpp
  TokenAnnotatorTest.cpp
  )

clang_target_link_libraries(FormatTests
  PRIVATE
  clangBasic
  clangFormat
  clangRewrite
  clangToolingCore
  )
