=== utils/ABITest/return-types-32/Makefile ===
X_CFLAGS := -m32
Y_CFLAGS := -m32
CC_CFLAGS := -m32

include ../Makefile.test.common

TESTARGS += --max-args 0
